/*
 * TranscodeTool.h
 * Copyright (C) 2008 doubleTwist Corporation
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#define kMDItemMediaType                @"kMDItemMediaType"
#define kMDItemFileFormat               @"kMDItemFileFormat"
#define kMDItemDuration                 @"kMDItemDuration"
#define kMDItemAverageBitrate           @"kMDItemAverageBitrate"
#define kMDItemHasAudio                 @"kMDItemHasAudio"
#define kMDItemTitle                    @"kMDItemTitle"
#define kMDItemArtist                   @"kMDItemArtist"
#define kMDItemAlbum                    @"kMDItemAlbum"
#define kMDItemGenre                    @"kMDItemGenre"

#define kMDImage                        @"kMDImage"
#define kMDVideo                        @"kMDVideo"
#define kMDEncoding                     @"kMDEncoding"
#define kMDDuration                     @"kMDDuration"
#define kMDAverageBitrate               @"kMDAverageBitrate"
#define kMDWidth                        @"kMDWidth"
#define kMDHeight                       @"kMDHeight"
#define kMDFrameRate                    @"kMDFrameRate"
#define kMDPixelAspectRatio             @"kMDPixelAspectRatio"
#define kMDDisplayAspectRatio           @"kMDDisplayAspectRatio"
#define kMDProfile                      @"kMDProfile"
#define kMDLevel                        @"kMDLevel"

#define kMDAudio                        @"kMDAudio"
#define kMDBitrate                      @"kMDBitrate"
#define kMDSampleRate                   @"kMDSampleRate"
#define kMDSampleSize                   @"kMDSampleSize"
#define kMDChannelCount                 @"kMDChannelCount"

@protocol TranscodeToolProtocol

- (NSDictionary *)getMetadataForFile:(oneway NSString *)file;
- (NSData *)getThumbnailForFile:(oneway NSString *)file usingArguments:(oneway NSArray *)arguments;
- (void)transcodeFiles:(oneway NSArray *)files toFile:(oneway NSString *)outputFile usingArguments:(oneway NSArray *)arguments;

@end

@protocol TranscodeProgressProtocol
- (bool)progressUpdate:(oneway NSString *)outputFile percentComplete:(oneway NSNumber *)percent;
- (void)transcodeCompleted:(oneway NSString *)outputFile successfully:(oneway BOOL)successfully;
@end

@interface MainThread : NSObject
{
    // keep this to allow the client to connect.
    NSString *myServerIdentifier;

    // keep these to track the parent process to see if it exits.
    int myParentProcessIdentifier;
    
    id myServerProxy;
}

- (void)run;

- (bool)progressUpdate:(NSString *)outputFile percentComplete:(NSNumber *)percent;
- (void)transcodeCompleted:(NSString *)outputFile successfully:(BOOL)successfully;

@end